<?php

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 AOE media GmbH <dev@aoemedia.de>
 *  All rights reserved
 *
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\CMS\Core\Tests\Unit\Utility\Fixtures\GeneralUtilityFixture;
use TYPO3\CMS\Core\Utility;

/**
 * @package FeatureFlag
 * @subpackage Tests
 * @author Roland Beisel <roland.beisel@aoe.com>
 */
class Tx_FeatureFlag_Tests_Unit_Service_EidTest extends Tx_FeatureFlag_Tests_Unit_BaseTest
{
    protected function setUp()
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $GLOBALS['TCA'] = array('pages' => array());
    }

    /**
     * @return PHPUnit_Framework_MockObject_MockObject
     */
    private function getServiceMock()
    {
        return $this->getMock(
            'Tx_FeatureFlag_Service', array('updateFeatureFlag'), array(), '', false
        );
    }

    /**
     * @return PHPUnit_Framework_MockObject_MockObject
     */
    private function getCacheManagerMock()
    {
        return $this->getMock(
            'Tx_FeatureFlag_System_Typo3_CacheManager', array('clearPageCache'), array(), '', false
        );
    }

    /**
     * @return array
     */
    public function featureProvider()
    {
        return array(
            array('activate', 'testfeature', true),
            array('deactivate', 'testfeature', false)
        );
    }

    /**
     * @test
     * @dataProvider featureProvider
     */
    public function shouldProcessRequestTest($action, $feature, $expected)
    {
        $_GET = array('action' => $action, 'feature' => $feature);

        $serviceMock = $this->getServiceMock();
        $serviceMock->expects($this->once())
            ->method('updateFeatureFlag')
            ->with($this->equalTo($feature), $this->equalTo($expected));

        $eid = new Tx_FeatureFlag_Service_Eid($serviceMock, $this->getCacheManagerMock());
        $eid->processRequest();
    }

    /**
     * @test
     */
    public function shouldThrowExceptionTest()
    {
        $_GET = array('action' => '', 'feature' => 'testfeature');
        $eid = new Tx_FeatureFlag_Service_Eid($this->getServiceMock(), $this->getCacheManagerMock());

        $this->setExpectedException(Tx_FeatureFlag_Service_Exception_ActionNotFound::class);
        $eid->processRequest();
    }
}